// MAPISample.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "sendnow.h"
#include "toolhelp.h"
#include "MAPI.h"
#include "ini.h"
#include "hidewindow.h"
#include "execute.h"
#include <windows.h>
#include <fstream>

/** R}hCp[^ */
BOOL g_ShowMenu = FALSE;
BOOL g_TouchLeft = FALSE;

/** W[nh */
HINSTANCE g_hInstance;

/**
 * dÕ`FbNs
 */
#define MUTEX_GUID _T("{D606D096-49DC-43e1-93E8-BF51F4A730FF}")
BOOL ExistInstance(HINSTANCE hInstance)
{
	CreateMutex(NULL, TRUE, MUTEX_GUID);
	return (GetLastError() == ERROR_ALREADY_EXISTS);
}

/**
 * R}hC̉͂sB
 * ͌ʂ̓O[oȕϐɓ˂ށB
 */
void ParseParam(LPTSTR lpCmdLine)
{
	LPTSTR param = NULL;
	param = wcstok(lpCmdLine, _T(" "));
	while (param != NULL) {
		if (wcscmp(param, _T("/showmenu")) == 0) {
			g_ShowMenu = TRUE;
		} else if (wcscmp(param, _T("/touchleft")) == 0) {
			g_TouchLeft = TRUE;
		}

		param = wcstok(NULL, _T(" "));
	}
}

/**
 * bZ[WEBhEǂ`FbNB
 */
BOOL IsMessageWindow(HWND hWnd)
{
	WCHAR text[256];
	HWND hChildWnd = NULL;

	//_CAOǂ`FbN
	if (!GetClassName(hWnd, text, 256) || wcscmp(text, _T("Dialog")) != 0) return FALSE;

	//q̃EBhEuWorkervǂׂ
	hChildWnd = GetWindow(hWnd, GW_CHILD);
	if (!hChildWnd) return FALSE;
	if (!GetClassName(hChildWnd, text, 256) || wcscmp(text, _T("Worker")) != 0) return FALSE;

	//̎qEBhEuPIEHTMLvǂׂ
	hChildWnd = GetWindow(hChildWnd, GW_CHILD);
	if (!hChildWnd) return FALSE;
	if (!GetClassName(hChildWnd, text, 256) || wcscmp(text, _T("PIEHTML")) != 0) return FALSE;

	//̎qEBhE邩ǂׂ
	hChildWnd = GetWindow(hChildWnd, GW_CHILD);
	if (!hChildWnd) return FALSE;

	//I
	return TRUE;
}

/**
 * j[^bvG~[gB
 *
 * @return G~[gɐTRUE
 */
BOOL TouchLeftMenu(HWND hWnd)
{
	HWND hMenuWnd = FindWindow(_T("MS_SOFTKEY_CE_1.0"), NULL);
	if (!hMenuWnd) return FALSE;

	DWORD dwProcId, dwMenuProcId;
	GetWindowThreadProcessId(hWnd, &dwProcId);
	GetWindowThreadProcessId(hMenuWnd, &dwMenuProcId);
	if (dwProcId != dwMenuProcId) return FALSE;

	SendMessage(hMenuWnd, WM_LBUTTONDOWN, 0, MAKELPARAM(0, 0));
	SendMessage(hMenuWnd, WM_LBUTTONUP, 0, MAKELPARAM(0, 0));

	return TRUE;
}

/**
 * uMgCɓvsB
 *
 * @return MgCɓꂽTRUE
 */
BOOL ExecToOutbox(HWND hWnd)
{
	return TouchLeftMenu(hWnd);
}

/**
 * uɑMvsǂ`FbNB
 *
 * @return MsKvȂTRUE
 */
BOOL CheckExecDirect(HWND hWnd)
{
	BOOL result = FALSE;
	if (ExecToOutbox(hWnd)) {
		//[MgCɂꍇ̂ݑMB
		MAPI::CMAPI mapi;
		MAPI::CSession session;
		MAPI::CMsgStore &msgStore = session.GetPdxAccount();
		MAPI::CFolder &folder = msgStore.GetOutboxFolder();
		if (folder.GetAllMessageCount() > 0) {
			result = TRUE;
		}
	}
	return result;
}

/**
 * |bvAbvj[\B
 *
 * @return MsKvȂTRUE
 */
BOOL ShowPopupMenu(HWND hWnd)
{

	//|bvAbvj[
	HMENU hMenu = CreatePopupMenu();
	if (!hMenu) return FALSE;

	//Tuj[
	if (!AppendMenu(hMenu, 0, ID_DIRECT, _T("ɑM"))) return FALSE;
	if (!AppendMenu(hMenu, 0, ID_TO_OUTBOX, _T("uMgCv"))) return FALSE;

	//\ʒu߂
	RECT rc;
	GetWindowRect(hWnd, &rc);

	BOOL result = FALSE;
	UINT id = TrackPopupMenu(hMenu, TPM_RETURNCMD | TPM_BOTTOMALIGN, rc.left, rc.bottom, 0, hWnd, NULL);
	switch (id) {
		case ID_TO_OUTBOX:
			ExecToOutbox(hWnd);
			break;
		case ID_DIRECT:
			result = CheckExecDirect(hWnd);
			break;
		default:
			break;
	}
	return result;
}

/**
 * SendNow̎s
 *
 * @return MsKvȂTRUE
 */
BOOL Exec(HWND hWnd)
{
	BOOL result = FALSE;
	if (IsMessageWindow(hWnd)) {
		//bZ[WʂȂs
		if (g_ShowMenu) {
			result = ShowPopupMenu(hWnd);
		} else {
			result = CheckExecDirect(hWnd);
		}
	} else {
		//bZ[WʈȊO͍j[G~[g
		TouchLeftMenu(hWnd);
	}
	return result;
}

/**
 * SendNow̎sǂ`FbNA
 * sĂ悯ΎsB
 * łȂ΁Aj[^bṽG~[gB
 *
 * @return MsKvȂTRUE
 */
BOOL CheckAndExec(void)
{
	BOOL result = FALSE;
	std::wstring ExecName;

	//݃ANeBuȃEBhE擾
	HWND hWnd = GetForegroundWindow();

	//ANeBuEBhEExe擾
	try {
		ExecName = GetModuleNameFromHwnd(hWnd);
	} catch (wchar_t *) {
		//Exe̎擾łȂĂAƂ肠sႤB
		result = Exec(hWnd);
	}

	if (ExecName == _T("tmail.exe")) {
		//słȂ΁Aj[^bv
		result = Exec(hWnd);
	} else {
		//ExeĂĂIvVw肪
		//j[^bv
		if (g_TouchLeft) {
			TouchLeftMenu(hWnd);
		}
	}

	return result;
}

void SetStatus15(void)
{
	HKEY hKey;
	LONG ret = RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\Sharp\\PhoneStatus"), 0, 0, &hKey);
	if (ret == ERROR_SUCCESS) {
		DWORD data = 1;
		ret = RegSetValueEx(hKey, _T("Status15"), 0, REG_DWORD, (LPBYTE)&data, sizeof(data));
		RegCloseKey(hKey);
	}
}

DWORD GetStatus15(void)
{
	HKEY hKey;
	DWORD data = 0xFFFFFFFF;
	DWORD type = REG_DWORD;
	DWORD size = 4;
	LONG ret = RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\Sharp\\PhoneStatus"), 0, 0, &hKey);
	if (ret == ERROR_SUCCESS) {
		ret = RegQueryValueEx(hKey, _T("Status15"), 0, &type, (LPBYTE)&data, &size);
		RegCloseKey(hKey);
	}

	return data;
}

/**
 * M[Ȃǂ`FbNB
 * uMgCv[ǂŔfĂB
 * 
 * @return M[cĂȂTRUE
 */
BOOL IsSendMessage(void)
{
	MAPI::CMAPI mapi;
	MAPI::CSession session;
	MAPI::CMsgStore &msgStore = session.GetPdxAccount();
	MAPI::CFolder &folder = msgStore.GetOutboxFolder();
	MAPI::CMessages &messages = folder.GetAllMessages();
	return (messages.size() == 0);
}

/**
 * TvIni쐬B
 */
void MakeNewIniFile(CIniFile &ini)
{
	std::wfstream stream(ini.GetIniFileName().c_str(), std::ios::out);
	if (stream.fail()) return;

	stream
		<< _T("[exec]") << std::endl
		<< _T("# MOɋNAv") << std::endl
		<< _T("before=") << std::endl
		<< std::endl
		<< _T("# MɋNAv") << std::endl
		<< _T("after=") << std::endl
		<< std::endl
		<< _T("# MɖM[ȂƂNAv") << std::endl
		<< _T("send=") << std::endl
	;
	stream.close();
}

HRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static CIniFile ini(g_hInstance);
	static UINT timerId;

	switch (uMsg) {
		case WM_CREATE:
			//init@CȂ΁ATvł쐬B
			if (ini.Fail()) {
				MakeNewIniFile(ini);
			}

			if (!CheckAndExec()) {
				SendMessage(hWnd, WM_CLOSE, 0, 0);
			} else {
				//MONAvN
				try {
					std::wstring path = ini.GetValue(_T("exec"), _T("before"));
					MomoLabUtil::ShellExecute(path);
				} catch (wchar_t *) {
					//Ȃ
				}

				//WXgL[ύXMJn
				SetStatus15();

				//^C}[Jn
				timerId = SetTimer(hWnd, 1, 500, NULL);
				if (!timerId) {
					SendMessage(hWnd, WM_CLOSE, 0, 0);
				}
			}
			break;

		case WM_TIMER:
			//WXg̒l`FbN
			if (GetStatus15() == 0xFFFFFFFF) {
				//M[邩`FbN
				BOOL ret = IsSendMessage();
				if (ret) {
					try {
						std::wstring path = ini.GetValue(_T("exec"), _T("send"));
						ret = MomoLabUtil::ShellExecute(path);
					} catch (wchar_t *) {
						ret = FALSE;
					}
				}
				if (!ret) {
					//MNAvN
					try {
						std::wstring path = ini.GetValue(_T("exec"), _T("after"));
						MomoLabUtil::ShellExecute(path);
					} catch (wchar_t *) {
						//Ȃ
					}
				}

				//I
				SendMessage(hWnd, WM_CLOSE, 0, 0);
			}
			break;

		case WM_DESTROY:
            PostQuitMessage(0);
            break;

		default:
            return DefWindowProc(hWnd, uMsg, wParam, lParam);
    }
    return 0;
}

/**
 * C
 */
int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	g_hInstance = hInstance;

	//dN`FbN
	if (ExistInstance(hInstance)) {
		return 1;
	}

	//R}hC
	ParseParam(lpCmdLine);

	//EBhE쐬
	CHideWindow window(hInstance);
	if (window.Create(WndProc)) {
		return window.Run();
	}
	
	return 0;
}
