#include "stdafx.h"
#include "toolhelp.h"
#include <tlhelp32.h>

std::wstring GetModuleNameFromHwnd(HWND hWnd)
{
	std::wstring result = _T("");

	//vZXID擾
	DWORD dwProcessId;
	GetWindowThreadProcessId(hWnd, &dwProcessId);

	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if (hSnapshot != INVALID_HANDLE_VALUE) {
		PROCESSENTRY32 pe;
		ZeroMemory(&pe, sizeof(PROCESSENTRY32));
		pe.dwSize = sizeof(PROCESSENTRY32);
		if (Process32First(hSnapshot, &pe)) {
			do {
				if (pe.th32ProcessID == dwProcessId) {
					result = pe.szExeFile;
					break;
				}
			} while (Process32Next(hSnapshot, &pe));
		}
		CloseHandle(hSnapshot);
	} else {
		throw _T("Snapshot쐬ł܂łB");
	}

	return result;
}